//-------------------------------------------------------BEGINHEADER--
// This file is part of LoopSim (arXiv:1006.2144).
//
// Copyright 2009-2011 Mathieu Rubin, Gavin P. Salam and Sebastian Sapeta
//
// This software is provided as a snapshot of the ongoing LoopSim
// research project. As such, you may not redistribute it without the
// authors' permission.
//
// If you use LoopSim as part of your scientific work, you should
// discuss and agree with the LoopSim authors how best to acknowledge
// LoopSim in your work (e.g. whether through a reference, or through
// joint authorship with the LoopSim authors). 
//
// To help guide LoopSim's proper use in its current early stage of
// development, a condition of use of LoopSim is that any results that
// you obtain with it must be shown to the LoopSim authors before
// they are made public.
//
// $Id: wjets.cc 1915 2013-06-29 13:58:09Z sapeta $
//-------------------------------------------------------ENDHEADER----

#include <iostream>
#include "LoopSimDriver.hh"
#include "LSAnalysisLHC.hh"
using namespace std;

int main(int argc, char ** argv) {

  string input_filename = string(argv[1]);
  // read LoopSim card file
  InputDat inputdat(input_filename);
  // pass analysis to LoopSimDriver, which takes care of reading input events,
  // gerating LoopSim events and analysising them and generating output
  LoopSimDriver lsdriver(argc,argv,inputdat);
  lsdriver.add_analysisRmid(new LSAnalysisLHC(0.4,30.0),"R04pt30");
  lsdriver.run();

}
