#include <iostream>
#include <cmath>
#include <cstring>
#include <string>
#include <cstdio>
#include <fstream>
#include <sstream>
#include <fastjet/PseudoJet.hh>
#include <fastjet/ClusterSequence.hh>
#include <mcfm.hh>
using namespace fastjet;
using namespace std;

//----------------------------------------------------------------------
/// return the scalar sum of the pt's of all particles
double ht_particles(int nd) {
  double ht = 0.0;
  for (int i = 2; i < 2+npart_.npart; i++) {
    ht += sqrt(pow(ptildes_.ptilde[0][i][nd],2) +
               pow(ptildes_.ptilde[1][i][nd],2));
  }
  return ht;
}

//----------------------------------------------------------------------
// the two user routines called by MCFM
extern "C" {

bool userincludedipole_(const int & nd, 
                        const double * ppart , 
                        const bool & mcfm_result) {
  bool result = mcfm_result;

  //if (ht_particles(nd) < 1000.0) return false;
  
  return result;
}


//----------------------------------------------------------------------
void userplotter_( const double * pjet, 
                   const double & wt,
                   const double & wt2,
                   const int    & nd) {

  static bool first = true;
  
  string tag; // tag: "book" to initialize histogram, "plot" to fill
  if (first) {
    first = false;
    tag = "book";
  } else {
    tag = "plot";
  }

}


// SSbegin
//----------------------------------------------------------------------
void userwriteinfo_(const int & unitno,
                    const char * comment_chars, // an array of size 2
                    const double & xsec,
                    const double & xsec_err,
                    const int & itno) {
  mcfmfwrite(unitno,comment_chars, "mcfmcc program comments");

}
 

// Function called by histofin at the end of each iteration and at the end of
// the run of MCFM
void userhistofin_(const double & xsec,
                   const double & xsec_err,
		   const int & itno, 
		   const int & itmx) {
}
// SSend

} // extern "C"
