c----------------------------------------------------------------------
c  Write  events in Les Houches Event File format
c 
c  The output is compatible with Les Houches however many entries are
c  just placeholders. The information which is meaningful is essentially
c  that which is needed for LoopSim analysis (weights, 4-momenta).
c
c  to-do:
c     * need for much better solution for passing pdg ids
c
c----------------------------------------------------------------------
      subroutine lhewrite(p,wt,facscale,it, nd)
      implicit none
      include 'npart.f'
      include 'constants.f'
      include 'scale.f'
      include 'qcdcouple.f'
      include 'vegas_common.f'
      include 'gridinfo.f'
      double precision p(mxpart,4)
      double precision wt, facscale, aemmz, sqrts
      double precision m2, m, vtimup, spinup
      integer nd, it
      integer mothup1, mothup2, nprup, getpdgid
      integer icolup1, icolup2 
      integer nproc, i, idup, istup, idbmup1, idbmup2, pdfgup1, pdfgup2
      integer pdfsup1, pdfsup2, idwtup
      integer itmx1,ncall1,itmx2,ncall2
      integer lenocc, origij
      character*4 part
      character*200 outfile
      character*255 runname
      character*255 gridname
      character*4 seedstr
      character*255 lhefile
      logical first
      data first/.true./
      save first


      common/nproc/nproc
      common/em/aemmz
      common/energy/sqrts
      common/iterat/itmx1,ncall1,itmx2,ncall2
      common/runname/runname
      common/part/part
      common/origij/origij
      character*2 plabel(mxpart)
      common/plabel/plabel
      common/lhe/lhefile

c     remarks:
c
c         facscale -- this is fine in usual case but sometimes different
c                     scale is used for pdfs, see e.g. lowint_incldip.f;
c                     same for real and virt
c         as       -- this is fine for lord, virt and real (non-dipole);  
c                     real (dipole) gets wrong as (that of real
c                      non-dipole)
c         istup    -- what to we do from (0,0,0,0) particle from dipole?
c                     we could set its status to 0 for example (non-phys)
c         beam     -- we should in principle include them in the
c         particles   output as well
c         fake     -- mothup(2), icolup(2), vtimp(1), spinup(1), idwtup
c         entries  
c         pdfs     -- (option in LH format) not stored for now
 
c     pdg id of incoming particle 1; shouldn't they be protons?
      idbmup1 = 81 
      idbmup2 = 81
      pdfgup1 = 0
      pdfgup2 = 0
      pdfsup1 = 0
      pdfsup2 = 0
      idwtup = 0
      nprup = 1
      if (first) then
        gridname = ingridfile
        write(seedstr, '(I4)') origij
        outfile = lhefile
        open(unit=7,file=outfile)
        write(7,'(A)') '<LesHouchesEvents version="1.0">'
        write(7,'(A)') '<!--'
        write(7,'(A)') 'File generated with MCFM 6.6'
        write(7,'(A)') '-->'
        write(7,'(A)') '<init>'
        write(7,10) idbmup1, idbmup2, sqrts/2, sqrts/2, pdfgup1,
     1              pdfgup2, pdfsup1, pdfsup2, idwtup, nprup
10      format(I3, 1X, I3, 1X, E13.6, 1X, E13.6, 1X, 
     1         I2, 1X, I2, 1X, I2, 1X, I2, 1X, I2, 1X, I2)
        do i=1,nprup
          write(7,11) 0d0, 0d0, 0d0, nproc
11        format(E13.6, 1X, E13.6, 1X, E13.6, 1X, I4)
        
        enddo
        write(7,'(A)') '</init>'
      first = .false.
      endif

      write(7,'(A)') '<event>'
      write(7,100) npart, nproc, wt, facscale, aemmz, as
100   format(I2, 1X, I4, 1X, E17.10, E13.6, E13.6, E13.6, E13.6)
      mothup1 = 0
      mothup2 = 0
      icolup1 = 0
      icolup2 = 0
      vtimup = 0d0
      spinup = 9d0

      do i=3,npart+2
c       set pdg
        idup = getpdgid(i)
c       calculate mass of the particle
        m2 =p(i,4)**2-p(i,1)**2-p(i,2)**2-p(i,3)**2
        if (m2 .gt. 0) then
          m = dsqrt(m2)
        else
          m = -dsqrt(-m2)
        endif


c       the format for particle line is: 
c         idup,      : pdg id
c         istup,     : status code (+1 for outgoing particle)
c         p(1,..,4), : particle 4-momentum, the format of p is (px, py, pz, E)
c       to be continued...

      if ((i .eq. 1) .or. (i .eq. 2)) then
        istup = -1
      else
        istup = 1
      endif
        write(7,101) idup, istup, mothup1, mothup2, icolup1, icolup2,
     1  p(i,1), p(i,2), p(i,3), p(i,4), m, vtimup, spinup
101   format(I3, 1X, I2, 1X, I1, 1X, I1, 1X, I3, 1X, I3, 1X
     1  E20.13, 1X, E20.13, 1X, E20.13, 1X, E20.13, 1X, E20.13, 1X,
     2  F3.0, 1X, F3.0)
      enddo
      write(7,102) '#', part, nd, it
102   format(A1, 1X, A4, 1X, I2, 1X, I4)
      write(7,'(A)') '</event>'

      end

c----------------------------------------------------------------------
c  function determining PDG id of a particle; original version implemented
c  known pdg IDs for a limited number of processes (see commented code at bottom) 
c
c  Current version of code looks into the plabel array to deduce the PDG ids of
c  each particle. 
c
c  - el = e-                       ->  11
c  - ea = e+                       -> -11
c  - na = electron anti-neutrino   -> -12
c  - nl = eletron neutrino         ->  12
c  - ga = gamma                    ->  22
c  - ml = mu-                      ->  13
c  - ma = mu+                      -> -13
c  - tl = tau-                     ->  15
c  - ta = tau+                     -> -15
c  - bq = b                        ->   5  (may sometimes be c, e.g. proc 19)
c  - ba = anti-b                   ->  -5  (may sometimes be anti-c)
c  - pp = generic parton           ->  81
c
c  Notes of unimplemented things and strange observations
c  - qj = quark jet (proc 161, single-top)
c  - ig = unknown, undecayed heavy quark or anti quark (procs 157-160) or other parton
c         (e.g. proc=190, ttH -- must look at process to be sure)
c  - in many processes (e.g. 61), mu/e labels are inconsistent wrt process.DAT
c----------------------------------------------------------------------
      integer function getpdgid(i)
      implicit none
      include 'constants.f'
      integer i
      integer nproc

      common/nproc/nproc
      ! this common block gives us the label of each particle
      ! NB: sometimes e/mu may be exchanged wrt what is written in the process.DAT file
      character*2 plabel(mxpart)
      common/plabel/plabel

      if      (plabel(i) .eq. 'el') then
         getpdgid =  11         ! = e-
      else if (plabel(i) .eq. 'ea') then
         getpdgid = -11         ! = e+                        
      else if (plabel(i) .eq. 'na') then
         getpdgid = -12         ! = electron anti-neutrino    
      else if (plabel(i) .eq. 'nl') then
         getpdgid =  12         ! = eletron neutrino          
      else if (plabel(i) .eq. 'pp') then
         getpdgid =  81         ! = generic parton            
      else if (plabel(i) .eq. 'ga') then
         getpdgid =  22         ! = gamma                     
      else if (plabel(i) .eq. 'ml') then
         getpdgid =  13         ! = mu-                       
      else if (plabel(i) .eq. 'ma') then
         getpdgid = -13         ! = mu+                       
      else if (plabel(i) .eq. 'bq') then
         getpdgid =   5         ! = b      (or sometimes c...)
      else if (plabel(i) .eq. 'ba') then
         getpdgid =  -5         ! = anti-b (or sometimes anti-c...) 
      else if (plabel(i) .eq. 'tl') then
         getpdgid =  15         ! = tau-                      
      else if (plabel(i) .eq. 'ta') then
         getpdgid = -15         ! = tau+                      
      else 
         write(0,*) 'Error determining pdg id of particle', plabel(i)
      end if
      return



C-OLD      if ((i .eq. 1) .or. (i .eq. 2)) then
C-OLD          getpdgid = 81
C-OLD      else 
C-OLDc       Z^0(->e^-+e^+) + 0, 1 or 2 partons
C-OLD        if (nproc .eq. 31 .or. nproc .eq. 41 .or.nproc .eq. 44) then
C-OLD          if (i .eq. 3) then
C-OLD            getpdgid = 11
C-OLD          elseif (i .eq. 4) then
C-OLD            getpdgid = -11
C-OLD          else
C-OLD            getpdgid = 81
C-OLD          endif
C-OLDc       W^+(->nu+e^+) + 0, 1 or 2 partons
C-OLD        elseif (nproc .eq. 1 .or. nproc .eq. 11 .or.nproc .eq. 22) then
C-OLD          if (i .eq. 3) then
C-OLD            getpdgid = 12
C-OLD          elseif (i .eq. 4) then
C-OLD            getpdgid = -11
C-OLD          else
C-OLD            getpdgid = 81
C-OLD          endif
C-OLDc       W^-(->e^-+~nu) + 0, 1 or 2 partons
C-OLD        elseif (nproc .eq. 6 .or. nproc .eq. 16 .or.nproc .eq. 27) then
C-OLD          if (i .eq. 3) then
C-OLD            getpdgid = 11
C-OLD          elseif (i .eq. 4) then
C-OLD            getpdgid = -12
C-OLD          else
C-OLD            getpdgid = 81
C-OLD          endif
C-OLDc       W^+(->nu-+mu^+) + Z^(->e^-+e^+) 
C-OLD        elseif (nproc .eq. 71) then
C-OLD          if (i .eq. 3) then
C-OLD            getpdgid = 14
C-OLD          elseif (i .eq. 4) then
C-OLD            getpdgid = -13
C-OLD          elseif (i .eq. 5) then
C-OLD            getpdgid = 11
C-OLD          elseif (i .eq. 6) then
C-OLD            getpdgid = -11
C-OLD          else
C-OLD            getpdgid = 81
C-OLD          endif
C-OLD        endif
C-OLD      endif
C-OLD      return
      end

      subroutine lhewrite_exit()
        write(7,'(A)') '</LesHouchesEvents>'
        close(7)
      end
