//-------------------------------------------------------BEGINHEADER--
// This file is part of LoopSim (arXiv:1006.2144).
//
// Copyright 2009-2011 Mathieu Rubin, Gavin P. Salam and Sebastian Sapeta
//
// This software is provided as a snapshot of the ongoing LoopSim
// research project. As such, you may not redistribute it without the
// authors' permission.
//
// If you use LoopSim as part of your scientific work, you should
// discuss and agree with the LoopSim authors how best to acknowledge
// LoopSim in your work (e.g. whether through a reference, or through
// joint authorship with the LoopSim authors). 
//
// To help guide LoopSim's proper use in its current early stage of
// development, a condition of use of LoopSim is that any results that
// you obtain with it must be shown to the LoopSim authors before
// they are made public.
//
// $Id: ExtractEventBase.hh 1919 2013-06-29 15:25:14Z sapeta $
//-------------------------------------------------------ENDHEADER----

#ifndef __EXTRACTEVENTBASE_HH__
#define __EXTRACTEVENTBASE_HH__
#include <iostream>      
#include <string>
#include "LoopSim.hh"
#include "InterfaceCommon.hh"

using namespace std;
using namespace fastjet;


/// Base class for exatracting NLO events
class ExtractEventBase {
  public:
  // constructor and destructor
  ExtractEventBase() {}
  virtual ~ExtractEventBase() {}
  /// read each line/particle and take action depending on its content;
  /// get pointer to next event if available, otherwise return zero
  virtual Event* next_event() {return 0;}
  virtual EventExtraInfo current_event_extra_info() const {
    return EventExtraInfo();}
  /// number of the current event
  virtual unsigned int iev() const {return 0;}
  /// number of the current iteration
  virtual int it() const {return 0;}
  /// true if we have just read all events from a single iteration
  virtual bool periodic_output() {return false;}
  /// true if we got the end of LHEF
  virtual bool end_of_file() const {return false;}
  virtual string generator() const {return "";}
  private:
};

#endif // __EXTRACTEVENTBASE_H__
